"""
CINEMA 4D MAXON LABS
(c) MAXON Computer GmbH, all rights reserved

Author : Adam Maxime
Email : m_adam@maxon.de

Pre-R12 Updater is a plugin that help you to track any old scenes that are made before R12.
"""

# localimport-v1.5.2_b64cm_70
if bool(True):
    import base64 as b, types as t, zlib as z; m=t.ModuleType('localimport'); blob=b'\
    eJydGctu4zbw7q8QsAdJG1XZbNGLUS36QAsULXooih5qGIIsUQ4bWRJIemsn2H/vzPApS856e0lEzoP\
    zniHND+MgVFQP4znbd8MuG2Q2Pu2PineZPMtMiapmu6p+yp752PKOrXgbASD/yITkQ1/yvh0277ZF8X\
    69ihrWRlyxg0xOKSwjwdRR9NEp15upwxDXsITFZJ1k1zl2XKrEsb2BL/Gsu0rKqBvqquOkdzLs/mG1Q\
    uyyrI7qcRBlWcS/8yfAjP4YJOulYryPvhXuuyfgd/tDxbu8Hg4fYiS25gDqh/yb/D1ujuevn4oFW30o\
    vgaoVIL3+1KdRyaLBFZZCqYlogiVT3aVZBopMwqWwIGrskwk69psrNQj/BGsV2XDRfH70LOsGUq238v\
    iT3Gkxage6ZsMAvz7QUWeBjejVlQHRnKWe6ZolTykeVtiPFSdRBygjMsS/V+WcQQGITQiD9gVg8xRqh\
    y+e2Rj19VO4v+EqDae0xZdF6E2hFdstlpKLjkYu+prlpCWhDGxGOkTaSL8i4TtIGinxLNRSFysjfiou\
    BWHSxAocaia1xXrQBhVXLLor6o7sp+EGEQSC9ZVin9kdEC0OyogDOji1NjF8Hdm+WfgfeLxMi/BahG/\
    H8SB7DZFdPbKq3FkfXMBBj1MFGgFPDo7KURHv+b4J7kQzHDJ4rc5kMep986Bqar0LtJ7Q3PsIHZfPtk\
    dE2/6n93kfVkPvYKzi58hmpgNZTACEyaWyQNKnLWzdEmCKlQKJoejqBnFYC8bXqsCS1XeMDbiRzLByk\
    l8CLWagbD1U7WHQEHShkHqC+bBxZRuBid/vI5S6KBcImWnmo0q+oUUoZhZBwpgni4LZSDEGMJfseIl1\
    kTxWv/P4hlVvJ5tZUCFzpLx+uVTFuNnvMYEx6/NepvFzp963y0J2GB+gGcNte4GJngM0cJmRmHgDylc\
    3Jn98JBiGlV3E/iKbH/J39g72DEp/8TOGcQiJrwu9GF06tzG0PJW3XgNtxug3lLxMwT5OIwJbFLcGEf\
    +ys7aiyP0D8pAj68ZwEJXriAPdHG9rEnOKjo5Ed72CLglK4ErZKWpS8YeH6sOT0vaflpPrCvuilBzct\
    /2quW8XqktnIQgI4xNU+8Fa/mpAOJcQDFTXEFvS+I8TqG32Ur6WMlKKRFyzKG7JJo4zaAHkLRlbNVpW\
    DezK/mgC9gBcE4a6mcD3ziWigUVCqDMLaGuz+FOsRBwE5JML9C4mv6ytmGT9TMHQl2hO/me/RaIg058\
    wYTU0e3mj2Ov+ME2HAMnGqqbrKEmQ6MMSSh1YbbhRpFmAsA6kvaRg43CSUhoUwYMw+aSGtaYopa1S1c\
    XKASUTrGo6hu9uXCoL0Bb131nuNMjLluRFRA3UEDbj8KQI9eni+FuRsVJuAMWto5htK0KtmBSoaYM0R\
    uGoJlgMswL23ZRdotP2sOJTiGQanfknQJ36zN1vQ5nKJ1Tcuy4wnzKHsKM0ijIyohsjLIkICWQJtguC\
    huZ8TqaKG1iGE9zmxHE30QnXXa4LClWHCwLQicNE3NSJ68U2nD7ODYQIclyuX7VlVdIXAcwkxcZCy3t\
    DJ1uvnq/Der9L33DTrbiexrbuJ0zSmeUcG3zI/SS8W9Y3wKSrbGW9p8GZJcSPmxR49AANtGXLeAqYdA\
    CL8prUP50O73W8GZt/bKbLPf3ea6/1totz4V5Y3vDeHjTuGajYzZEbecsFobJvO5YJZL0NuSFSDbTHM\
    XxwpRozb08N+sW6biZ/uIykRqMS0e0G96SyfuuRswuZAZgw2p2fUIW7qpVLvKY3T5chZDH3eSUYEDRa\
    WG65bR3hrcEN91MlZMQ7nCBClupv9shlldM91TiDF//ckiZAdqGlymG+xpc9tvRzWsc0z/reE9WYP3x\
    wAQ6sh39TRGh6AahJPJMYh2WbppBeNn2Rfzy7tObl4dPcQ6cD5Xy59Ipdw+6HLvophxkdVIPhxH1QD6\
    ZYZbFCIpTQ2Li54dKsp/oE8Ywy8M92+Qj3JkVzCB1Miv8JEFBmrTwncRvzM2VruAI/PBujWDC2axpa+\
    v1K4wRBB8TTzi/aCOatYsmnEy4l48GznWkd7qak7l7cYBgfELVmD6CvhuMEG4N+SWZUMk7ewrF26ww2\
    KcWSmkfup8pJsmEQM8mF8Xfw7erL51FL7jrTAmQtcxwJXPyIsozH0uTHc8eEuEXDB3kxfheR4DJRFsI\
    nnP8ojc3BI/zR423xMW3K0R7JjRgqVEWMOg1azwXsX3Yiu+AK2gi2XgXj+fY49RXkeoAa7iKNcTayrr\
    fkCqjn2uvjczmzRPiuDSfehzWweRzlu33hcX9m48/W0QqLhqlaho6OgncAGQZWekuvrdy56B2CiJ9Hq\
    2+EW9wFaMlCWbXS/2S+OxKOKlu5KV8asOrgzWiTSi7tuN4ay8MtkIl1jI/VM3f+tM+Jue/VWLPjMVsi\
    cAmGK0mpeqa3F5kkNgXHagk2k96NLsqu/PJRfOYn2TiK0WL34pcfxH2kKbLxv8S21vT6/zdzOrlKcVo\
    P4WsoPp8h4WM1zCmPeIzhp0qbPcmKSv5VNqOa+NesG7iGLOeEvhBx7+gBj1Zd/vId3/LFLnWRwEs4AZ\
    C+htI2HXpZKGPQbHN1K8LoK614YwQPCtr4NWH5Y1+xzHspmYDuu1kqABDleZRRIPvoMAFF1J6IL1+a1\
    l4cwHEwvCKNF2otT8vKEThRQWO1wF2cYdYwyUizMzPXXSiw/yN639df266/4QzUIMv7K/dhaYz0PeAy\
    3dHFYSXKSQ3X/2vPT+99myIFgl+Nwp+WMr99ir8cWiK4vZX7IRbMoRHqzJYTSFvoh8FA5GaaHeOxvMB\
    akjLmYiSR6VGub6/30OcHHf489R9x1s1tO29R0tXq/8AypSWYQ=='
    exec(z.decompress(b.b64decode(blob)), vars(m)); _localimport=m;localimport=getattr(m,"localimport")
    del blob, b, t, z, m;

import c4d
import sys
import os

with localimport('.') as _importer:
    from src.Dialog import Dialog
    from src.Const import Const
    from src.CommandLine import CommandLine

class DlgOption(c4d.gui.GeDialog):
    def __init__(self):
        self.version = 12.00
        self.cancel = False

    def CreateLayout(self):
        self.GroupBegin(1000, c4d.BFH_SCALEFIT | c4d.BFV_SCALEFIT, cols=2)
        self.AddStaticText(1001, c4d.BFH_LEFT, name="Minimum version")
        self.AddEditNumberArrows(1002, c4d.BFH_SCALEFIT)
        self.GroupEnd()
        self.AddDlgGroup(c4d.DLG_OK | c4d.DLG_CANCEL)
        return True

    def InitValues(self):
        self.SetFloat(1002, self.version, 1, Const.CURRENT_C4D_VERSION, 0.001)
        return True

    def Command(self, id, msg):
        if id == c4d.DLG_OK:
            self.version = self.GetFloat(1002)
            self.Close()
            return True

        if id == c4d.DLG_CANCEL:
            self.cancel = True
            self.version = 12.00
            self.Close()
            return True

        if id == 1002:
            self.version = self.GetFloat(1002)
        return True

class MainCommand(c4d.plugins.CommandData):

    def __init__(self):
        self.dialog = None

    def Execute(self, doc):
        # Below R19 we print a message
        if c4d.GetC4DVersion() < 19000:
            c4d.gui.MessageDialog("Versions below R19 are only supported through commandline.\nPlease read the readme.")
            return True

        # After R20
        if c4d.GetC4DVersion() >= 20000:
            c4d.gui.MessageDialog("SceneUpdater works only on versions below R20.\nPlease read the readme.")
            return True

        if self.dialog is None:
            self.dialog = Dialog()

        return self.dialog.Open(c4d.DLG_TYPE_ASYNC, pluginid=Const.PLUGIN_ID, defaultw=500, defaulth=500)

    def ExecuteOptionID(self, doc, plugid, subid):
        # Below R19 we print a message
        if c4d.GetC4DVersion() < 19000:
            c4d.gui.MessageDialog("Versions below R19 are only supported through commandline.\nPlease read the readme.")
            return True

        # After R20
        if c4d.GetC4DVersion() >= 20000:
            c4d.gui.MessageDialog("SceneUpdater works only on versions below R20.\nPlease read the readme.")
            return True

        dlg = DlgOption()
        dlg.Open(c4d.DLG_TYPE_MODAL, pluginid=Const.PLUGIN_ID, defaultw=0, defaulth=0)

        if self.dialog is None:
            self.dialog = Dialog(dlg.version)
        else:
            self.dialog.SetMinimalVersion(dlg.version)
            self.dialog.Close()

        if dlg.cancel:
            return True
        return self.dialog.Open(c4d.DLG_TYPE_ASYNC, pluginid=Const.PLUGIN_ID, defaultw=500, defaulth=500)

def PluginMessage(id, data):
    if id==c4d.C4DPL_COMMANDLINEARGS:
        for arg in reversed(sys.argv):
            if arg.startswith("-SceneUpdater"):
                # After R20
                if c4d.GetC4DVersion() >= 20000:
                    c4d.GePrint("SceneUpdater works only on versions below R20.\nPlease read the readme.")
                    return True
                CommandLine(arg)

        return True

    return False

if __name__ == "__main__":
    dir, file = os.path.split(__file__)
    bmp = c4d.bitmaps.BaseBitmap()
    bmp.InitWith(os.path.join(dir, "sceneupdater.png"))
    c4d.plugins.RegisterCommandPlugin(id=Const.PLUGIN_ID,
                                  str="Scene Updater v{0}".format(Const.VERSION),
                                  help="Scene Updater v{0}".format(Const.VERSION),
                                  info=c4d.PLUGINFLAG_COMMAND_OPTION_DIALOG,
                                  dat=MainCommand(),
                                  icon=bmp)